#!/sbin/sh
#
# @(#)return.sh	1.14  09/11/98 SMI
# Portions Copyright (c) 1996, 1997 Sun Microsystems, Inc.
# All Rights Reserved.
#
#
# Copyright (c) 1994, 1997 Innosoft International, Inc.
# All Rights Reserved.
#
# return - shell script to return old messages.
#
#

#
# we have to hard code the path to the tailor file.
#
#
IMTATAILOR=/etc/opt/SUNWmail/imta/imta_tailor

##################################################################
# give some initial default values to all paths.
##################################################################
IMTAPATH=/opt/SUNWmail/imta
IMTALOGPATH=/var/opt/SUNWmail/imta/log


##################################################################
# shell function to get a variable's value
# from tailor file.
##################################################################
getTailorValue() {
 y=`/bin/grep $1 $IMTATAILOR |/bin/awk -F= '{print $2}'`
 echo $y
}

##################################################################
# shell function to get some values from tailor file.
##################################################################
getValuesFromTailor() {
  IMTAPATH=`getTailorValue IMTA_ROOT`
  IMTALOGPATH=`getTailorValue IMTA_LOG`
}

##################################################################
# try to read and reinitialize all the paths from the tailor file
# if it exists.
##################################################################
if test -f $IMTATAILOR; then
  getValuesFromTailor
fi

##################################################################
# real action begins now.
##################################################################

# get and increment the number of times we have run since the last reboot.
#$IMTAPATH/lib/get_count return | read return_count
return_count=`$IMTAPATH/lib/get_count return`

# resynchronize the queue cache according to the period set
period=`getTailorValue IMTA_RETURN_SYNCH_PERIOD`
if [ -z "$period" ]
then
  period=1
elif [ $period -lt 1 ]
then
  period=1
fi
if [ `expr $return_count % $period` -eq 0 ]
then
  $IMTAPATH/lib/close_cache
  $IMTAPATH/lib/synch_cache cache -sync
fi

# return old messages according to the period set
return_period=`getTailorValue IMTA_RETURN_PERIOD`
if [ -z "$return_period" ]
then
  return_period=1
elif [ $return_period -lt 1 ]
then
  return_period=1
fi
if [ `expr $return_count % $return_period` -eq 0 ]
then
  $IMTAPATH/lib/return
fi

# purge old versions of log files (use default to keep 5 lastest versions).
if [ $# -gt 1 ]
then
    $IMTAPATH/lib/purge $*
else
    $IMTAPATH/lib/purge $IMTALOGPATH/*.log- $IMTALOGPATH/*.trn- $IMTALOGPATH/*.trc-
fi

# startup a new mail.log
split_period=`getTailorValue IMTA_RETURN_SPLIT_PERIOD`
if [ -z "$split_period" ]
then
  split_period=1
elif [ $split_period -lt 1 ]
then
  split_period=1
fi
if [ `expr $return_count % $split_period` -eq 0 ]
then
  if [ -f $IMTALOGPATH/mail.log_yesterday ]
  then
    cat $IMTALOGPATH/mail.log_yesterday >> $IMTALOGPATH/mail.log
    chmod 600 $IMTALOGPATH/mail.log
    rm $IMTALOGPATH/mail.log_yesterday
  fi
  if [ -f $IMTALOGPATH/mail.log_current ]
  then
  mv $IMTALOGPATH/mail.log_current $IMTALOGPATH/mail.log_yesterday
  fi
fi

# do any site specific stuff
clean_period=`getTailorValue IMTA_RETURN_CLEANUP_PERIOD`
if [ -z "$clean_period" ]
then
  clean_period=1
elif [ $clean_period -lt 1 ]
then
  clean_period=1
fi
if [ `expr $return_count % $clean_period` -eq 0 ]
then
  if [ -f $IMTAPATH/lib/daily_cleanup ]
  then
    $IMTAPATH/lib/daily_cleanup
  fi
fi

###########################################################################
# Remove autoreply and dirsync logs
###########################################################################

rm -f $IMTALOGPATH/autoreply-sims.trc*
rm -f $IMTALOGPATH/dirsync.trc*

